﻿#Importation du module graphique
import matplotlib.pyplot as plt
import numpy as np

"""Equation : aA + bB = cC + dD"""

#Demande des nombre stoechiomètriques à l'utilisateur
a=float(input("Donner le nombre stoechométrique de la molécule A"))
b=float(input("Donner le nombre stoechométrique de la molécule B"))
c=float(input("Donner le nombre stoechométrique de la molécule C"))
d=float(input("Donner le nombre stoechométrique de la molécule D"))

#Demande du nombre de mols à l'état initial pour les réactif et les produits
na_i=float(input("Quelle est la quantité de matière initiale de l'espèce A en mole ?"))
nb_i=float(input("Quelle est la quantité de matière initiale de l'espèce B en mole ?"))
nc_i=float(input("Quelle est la quantité de matière initiale de l'espèce C en mole ?"))
nd_i=float(input("Quelle est la quantité de matière initiale de l'espèce D en mole ?"))

#Calcul du xmax avec condition avec affichage de la valeur de xmax et de l'espèce limitante

x1=na_i/a
x2=nb_i/b
if x1<x2:
    xmax=x1
    println("Le réactif limitant est le réactif A")
    println("L'avancement maximal est", xmax)

else:
    xmax=x2
    print("Le réactif limitant est le réactif B")
    print("L'avancement maximal est", xmax)

"""Représentation graphique"""

#définition de valeurs de x
x=np.arange(0, (xmax+0.1),0.1)

#définition des courbes
fA=na_i-(a*x)
fB=nb_i-(b*x)
fC=nc_i+(c*x)
fD=nd_i+(d*x)

#Création des courbes
plt.plot(x,fA, label="réactif A")
plt.plot(x,fB, label="réactif B")
plt.plot(x,fC, label="produit C")
plt.plot(x,fD, label="produit D")

#Création noms
plt.xlabel("Avancement")
plt.ylabel("Quantité de matière (mol)")
plt.title("Evolution des quantités de matières des réactifs et des produits")

plt.legend()
plt.show()

